AbstractClasspathResource (Apache Ant API)
Keywords: org.apache.tools.ant.types.resources.AbstractClasspathResource class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tools.ant.types.resources
Class AbstractClasspathResource

    java.lang.Object
      org.apache.tools.ant.ProjectComponent
          org.apache.tools.ant.types.DataType
              org.apache.tools.ant.types.Resource
                  org.apache.tools.ant.types.resources.AbstractClasspathResource

All Implemented Interfaces:
  java.lang.Cloneable, java.lang.Comparable, ResourceCollection

Direct Known Subclasses:
  JavaConstantResource, JavaResource

    public abstract class AbstractClasspathResource

extends Resource

A Resource representation of anything that is accessed via a Java classloader. The core methods to set/resolve the classpath are provided.

Since:
  Ant 1.8.0

Nested Class Summary
`static class` | `AbstractClasspathResource.ClassLoaderWithFlag`

Field Summary

Fields inherited from class org.apache.tools.ant.types.Resource
`MAGIC, UNKNOWN_DATETIME, UNKNOWN_SIZE`

Fields inherited from class org.apache.tools.ant.types.DataType
`checked, ref`

Fields inherited from class org.apache.tools.ant.ProjectComponent
`description, location, project`

Constructor Summary
`AbstractClasspathResource()`

Method Summary
`Path` | `createClasspath()` Add a classpath to use when looking up a resource.
`protected void` | `dieOnCircularReference(java.util.Stack stk, Project p)` Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
`protected AbstractClasspathResource.ClassLoaderWithFlag` | `getClassLoader()` combines the various ways that could specify a ClassLoader and potentially creates one that needs to be cleaned up when it is no longer needed so that classes can get garbage collected.
`Path` | `getClasspath()` get the classpath used by this `LoadProperties`.
`java.io.InputStream` | `getInputStream()` Return an InputStream for reading the contents of this Resource.
`Reference` | `getLoader()` Get the loader.
`boolean` | `isExists()` Learn whether this resource exists.
`protected abstract java.io.InputStream` | `openInputStream(java.lang.ClassLoader cl)` open the inpout stream from a specific classloader
`void` | `setClasspath(Path classpath)` Set the classpath to use when looking up a resource.
`void` | `setClasspathRef(Reference r)` Set the classpath to use when looking up a resource, given as reference to a <path> defined elsewhere
`void` | `setLoaderRef(Reference r)` Use the reference to locate the loader.
`void` | `setParentFirst(boolean b)` Whether to consult the parent classloader first.
`void` | `setRefid(Reference r)` Overrides the super version.

Methods inherited from class org.apache.tools.ant.types.Resource
`as, clone, compareTo, equals, getLastModified, getMagicNumber, getName, getOutputStream, getSize, hashCode, isDirectory, isFilesystemOnly, iterator, setDirectory, setExists, setLastModified, setName, setSize, size, toLongString, toString`

Methods inherited from class org.apache.tools.ant.types.DataType
`checkAttributesAllowed, checkChildrenAllowed, circularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes`

Methods inherited from class org.apache.tools.ant.ProjectComponent
`getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### AbstractClasspathResource

    public AbstractClasspathResource()

Method Detail

### setClasspath

    public void setClasspath(Path classpath)

  Set the classpath to use when looking up a resource.

  Parameters:
    `classpath` - to add to any existing classpath

### createClasspath

    public Path createClasspath()

  Add a classpath to use when looking up a resource.

  Returns:
    The classpath to be configured

### setClasspathRef

    public void setClasspathRef(Reference r)

  Set the classpath to use when looking up a resource, given as reference to a <path> defined elsewhere

  Parameters:
    `r` - The reference value

### getClasspath

    public Path getClasspath()

  get the classpath used by this `LoadProperties`.

  Returns:
    The classpath

### getLoader

    public Reference getLoader()

  Get the loader.

  Returns:
    the loader.

### setLoaderRef

    public void setLoaderRef(Reference r)

  Use the reference to locate the loader. If the loader is not found, taskdef will use the specified classpath and register it with the specified name. This allow multiple taskdef/typedef to use the same class loader, so they can be used together. It eliminate the need to put them in the CLASSPATH.

  Parameters:
    `r` - the reference to locate the loader.

### setParentFirst

    public void setParentFirst(boolean b)

  Whether to consult the parent classloader first.

  Only relevant if a classpath has been specified.

  Since:
    Ant 1.8.0

### setRefid

    public void setRefid(Reference r)

  Overrides the super version.

  Overrides:
    `setRefid` in class `Resource`
  Parameters:
    `r` - the Reference to set.

### isExists

    public boolean isExists()

  Learn whether this resource exists. This implementation opens the input stream as the test.

  Overrides:
    `isExists` in class `Resource`
  Returns:
    true if this resource exists.

### getInputStream

    public java.io.InputStream getInputStream()
                                       throws java.io.IOException

  Return an InputStream for reading the contents of this Resource.

  Overrides:
    `getInputStream` in class `Resource`
  Returns:
    an InputStream object.
  Throws:
    `java.io.IOException` - if an error occurs.

### getClassLoader

    protected AbstractClasspathResource.ClassLoaderWithFlag getClassLoader()

  combines the various ways that could specify a ClassLoader and potentially creates one that needs to be cleaned up when it is no longer needed so that classes can get garbage collected.

### openInputStream

    protected abstract java.io.InputStream openInputStream(java.lang.ClassLoader cl)
                                                    throws java.io.IOException

  open the inpout stream from a specific classloader

  Parameters:
    `cl` - the classloader to use. Will be null if the system classloader is used
  Returns:
    an open input stream for the resource
  Throws:
    `java.io.IOException` - if an error occurs.

### dieOnCircularReference

    protected void dieOnCircularReference(java.util.Stack stk,
                                          Project p)

  Description copied from class: `DataType`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

  If one is included, throw a BuildException created by `circularReference`.

  This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

  The general contract of this method is that it shouldn't do anything if ``checked`` is true and set it to true on exit.

  Overrides:
    `dieOnCircularReference` in class `DataType`
  Parameters:
    `stk` - the stack of references to check.
    `p` - the project to use to dereference the references.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD